#pragma once
#pragma unmanaged
#include "orbitersdk.h"
#pragma managed
#include <vcclr.h>

using namespace System::Reflection;

namespace Orbiter
{
	namespace Multiplayer
	{
		namespace Client
		{
			public ref class Launcher
			{
			public:
				Launcher();
				void Start();
				void Stop();
				void Update();
				void Propagate();
				void Add(char *message);
				void Up();
				void Down();
				void GenerateSNTPLog();
				System::IntPtr GetNewWindow();
				void SaveConfig();
				void Log(int level, char *message);
				void Analyse();
				virtual property double Now{double get(void);};
				virtual property double NowLocal{double get(void);};
			private:
				Object^ managed;
				MethodInfo^ start;
				MethodInfo^ stop;
				MethodInfo^ update;
				MethodInfo^ propagate;
				MethodInfo^ add;
				MethodInfo^ up;
				MethodInfo^ down;
				MethodInfo^ generateSNTPLog;
				MethodInfo^ getNewWindow;
				MethodInfo^ saveConfig;
				MethodInfo^ log;
				MethodInfo^ analyse;
				PropertyInfo^ now;
				PropertyInfo^ nowLocal;
				PropertyInfo^ synchronizationAverage;
				PropertyInfo^ synchronizationMaximum;
				PropertyInfo^ synchronizationMinimum;
				PropertyInfo^ clockVisibility;
				PropertyInfo^ clockPulseVisibility;
				PropertyInfo^ sampleWaitTime;
				PropertyInfo^ synchronizationWaitTime;
				PropertyInfo^ logger;
				PropertyInfo^ mjdAverage;
				PropertyInfo^ mjdMaximum;
				PropertyInfo^ mjdMinimum;
				PropertyInfo^ systemVisibility;
				PropertyInfo^ pulse;
				PropertyInfo^ name;
				PropertyInfo^ password;
				PropertyInfo^ ip;
				PropertyInfo^ tcp;
				PropertyInfo^ udp;
				PropertyInfo^ method;
				PropertyInfo^ scenario;
			};

			public class Wrapper
			{
			public:
				Wrapper(Launcher^ launcher);
				void Start();
				void Stop();
				void Update();
				void Propagate();
				void Add(char *message);
				void Up();
				void Down();
				void GenerateSNTPLog();
				HWND GetNewWindow();
				void SaveConfig();
				void Log(int level, char *message);
				void Analyse();
				double Now(bool compensated);
			private:
				gcroot<Launcher^> launcher;
			};
		}	
	}
}
