#define STRICT
#define ORBITER_MODULE

#define STRICT
#define ORBITER_MODULE

#include <orbitersdk.h>
#include "ORRL_CHKPT.h"
#include <stdio.h>

ORRL_CHKPT::ORRL_CHKPT(OBJHANDLE hVessel, int flightmodel) : VESSEL2(hVessel, flightmodel)
{
	beacons = NULL;
	beaconCount = 0;
}
ORRL_CHKPT::~ORRL_CHKPT()
{
	if (beacons)
	{
		for (int i = 0; i < beaconCount; i++)
		{
			delete beacons[i].pos;
			delete beacons[i].col;
		}
		delete [] beacons;
	}
}

void ORRL_CHKPT::clbkPreStep(double simt, double simdt, double mjd)
{
}	
void ORRL_CHKPT::clbkSetClassCaps (FILEHANDLE cfg)
{
	SetSize (2000);
	SetEmptyMass (5000);
	SetTouchdownPoints (_V(0,-0.5,2), _V(-1,-0.5,-1.5), _V(1,-0.5,-1.5));

	oapiReadItem_int(cfg, "BeaconCount", beaconCount);

	beacons = new BEACONLIGHTSPEC[beaconCount];
	char buff[255], shape[25];
	char beaconShapes[3][3][25] = 
	{
		{"compact", "Compact", "COMPACT"},
		{"diffuse", "Diffuse", "DIFFUSE"},
		{"star",    "Star",    "STAR"}
	};
	for (int i = 0; i < beaconCount; i++)
	{
		beacons[i].col = new VECTOR3();
		beacons[i].pos = new VECTOR3();

		beacons[i].active=true;
		sprintf(buff, "Beacon_%d_col", i+1);
		oapiReadItem_vec(cfg, buff, *beacons[i].col);
		sprintf(buff, "Beacon_%d_duration", i+1);
		oapiReadItem_float(cfg, buff, beacons[i].duration);
		sprintf(buff, "Beacon_%d_falloff", i+1);
		oapiReadItem_float(cfg, buff, beacons[i].falloff);
		sprintf(buff, "Beacon_%d_period", i+1);
		oapiReadItem_float(cfg, buff, beacons[i].period);
		sprintf(buff, "Beacon_%d_pos", i+1);
		oapiReadItem_vec(cfg, buff, *beacons[i].pos);
		sprintf(buff, "Beacon_%d_shape", i+1);
		oapiReadItem_string(cfg, buff, shape);
		for (int j = 0; j < 3; j++)
		{
			if (!strcmp(shape, beaconShapes[j][0]) || !strcmp(shape, beaconShapes[j][1]) || !strcmp(shape, beaconShapes[j][2]))
			{
				beacons[i].shape = j;
				break;
			}
		}
		sprintf(buff, "Beacon_%d_size", i+1);
		oapiReadItem_float(cfg, buff, beacons[i].size);
		sprintf(buff, "Beacon_%d_tofs", i+1);
		oapiReadItem_float(cfg, buff, beacons[i].tofs);
		AddBeacon(&beacons[i]);
	}
}
DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
	return new ORRL_CHKPT (hvessel, flightmodel);
}
DLLCLBK void ovcExit (VESSEL *vessel)
{
	if (vessel) delete (ORRL_CHKPT*)vessel;
}