//############################################################################//
#ifndef _H_COMPUTEREX_RACER_CHECKPOINT_MFD_FOR_WEHAVEAPROBLEM_H_
#define _H_COMPUTEREX_RACER_CHECKPOINT_MFD_FOR_WEHAVEAPROBLEM_H_
//############################################################################//
#include "VOBJ.h"
//############################################################################//
enum RCPPAGE { PAGE_MAIN,PAGE_VESSELINFO,PAGE_RACEMAP,NUM_OF_PAGES };
//############################################################################//
//############################################################################//    
//############################################################################//
class MFDData
{
public:   
//############################################################################//
 MFDData(OBJHANDLE h)
 {
  hook=new VOBJ(h);
  iSelectedCheckPoint=iSelectedTarget=0;
  page=PAGE_MAIN;  
  zoom=1;
 } 
//############################################################################//
 MFDData()
 {
  hook=new VOBJ();
  iSelectedCheckPoint=iSelectedTarget=0;
  page=PAGE_MAIN;
  zoom=1;
 }   
//############################################################################//
 ~MFDData()
 {
  delete hook;
 }  
//############################################################################//
 void nextPage()
 {
  int i=(int)page;
  if (i+1 >= (int)NUM_OF_PAGES)
   page=(RCPPAGE)0;
  else
   page=(RCPPAGE)((int)page+1);
 } 
//############################################################################//
 void nextTarget()
 {
  UINT count=oapiGetVesselCount();
  if (iSelectedTarget+1 >= count)
   iSelectedTarget=0;
  else
   iSelectedTarget++;
 }  
//############################################################################//
 void prevTarget()
 {
  UINT count=oapiGetVesselCount();
  if (count<2) return;
  if (iSelectedTarget==0)
   iSelectedTarget=count-1;
  else
   iSelectedTarget--;
 }   
//############################################################################//
 void TimeStep()
 {
  hook->TimeStep();
 }  
//############################################################################//
//############################################################################//
 RCPPAGE page;
 VOBJ * hook; 
 UINT iSelectedCheckPoint,iSelectedTarget;
 double zoom;
};   
//############################################################################//
//############################################################################//
//############################################################################//
class RCPMFD:public MFD {
public:
 RCPMFD (DWORD w,DWORD h,VESSEL *vessel);
 ~RCPMFD ();
 bool ConsumeKeyBuffered (DWORD key);
 bool ConsumeButton (int bt,int event);
 char *ButtonLabel (int bt);
 int  ButtonMenu (const MFDBUTTONMENU **menu) const;
 void Update (HDC hDC);
 void DrawPageMain(HDC hDC);
 void DrawPageVesselInfo(HDC hDC);
 void DrawPageRaceMap(HDC hDC);
 void ReadStatus(FILEHANDLE scn);
 void WriteStatus(FILEHANDLE scn) const;
 static int MsgProc(UINT msg,UINT mfd,WPARAM wparam,LPARAM lparam);
 MFDData * data;
 DWORD height,width,wm,hm;
};
//############################################################################//
#endif 
//############################################################################//